# SPDX-FileCopyrightText: Emery Hemingway
#
# SPDX-License-Identifier: LicenseRef-Hippocratic-1.1

{ releaseInputs, pullRequests }:

with builtins;

let
  pullRequests' = fromJSON (readFile pullRequests);

  prToJob = pr: {
    name = "solo5-${toString pr.number}";
    value = {

      description = pr.title;
      nixexprpath = "hydra/solo5.nix";
      enabled = 1;
      hidden = false;
      nixexprinput = "genodepkgs";
      checkinterval = 300;
      schedulingshares = 100;
      enableemail = false;
      emailoverride = "";
      keepnr = 8;

      inputs = releaseInputs // {

        prSrc = {
          type = "git";
          value = "https://github.com/Solo5/solo5.git pull/${
              toString pr.number
            }/head";
          emailresponsible = false;
        };

      };

    };
  };

  jobs = map prToJob (attrValues pullRequests');

in listToAttrs jobs
